/*
QUSOFT MICROSYSTMES
1869

Classe: TItem - Type Item

Hirarchie:
TObject -> TItem
*/

/*
		Copyright 2001 Frdric Brown
*/

/*
    This file is part of Gundealer.

    Gundealer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Gundealer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Gundealer; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
 * TItem class represents an item sold at a shop.
*/

//Structure de l'objet de Type Item  extension de TObject
typedef struct Item  {
	char *class; 	//Le nom de la classe
	char *super; 	//Le nom de la superclasse
	struct Object*	(*clone)		(struct Object*);
	BOOL						(*equals)		(struct Object*, struct Object*);
	void						(*finalize)	(struct Item*);
	TString* 				(*toString) (struct Item*);
	TGood* good;
	float price;
	int market;
} TItem ;

//Dclaration des constructeurs
TItem* TItem0(TGood*, float, int);

//Dclaration des mthodes
void 			TItem_finalize		(TItem*);
TString*	TItem_toString		(TItem*);

/**
 * Ce constructeur instancie un objet de Type Item.
 @since Release 1.0
*/
TItem* TItem0 (TGood* good, float price, int market) {

	TItem *this = (TItem*)malloc(sizeof(TItem));
	
	this->class  = "TItem";
	this->super  = "TObject";
	
	this->clone    = TObject_clone;
	this->equals   = TObject_equals;
	this->finalize = TItem_finalize;
	this->toString = TItem_toString;
	
	this->good 		= good;
	this->price 	= price;
	this->market	= market;
	
	return this;
}

TString* TItem_toString	(TItem* this) {

	return this->good->toString(this->good);
}

void TItem_finalize	(TItem* this) {
	
	free(this);
}


